require "yaml"

class Array
  # Standard in Ruby 1.8.7+. See official documentation[http://ruby-doc.org/core-1.9/classes/Array.html]
  def shuffle
    dup.shuffle!
  end unless method_defined? :shuffle

  # Standard in Ruby 1.8.7+. See official documentation[http://ruby-doc.org/core-1.9/classes/Array.html]
  def shuffle!
    size.times do |i|
      r = i + Kernel.rand(size - i)
      self[i], self[r] = self[r], self[i]
    end
    self
  end unless method_defined? :shuffle!
end

# Workaround for Ruby 3.1
# All code switched to using YAML.unsafe_load
# If inot available in older rubies, alias is created to YAML.load
module YAML
	# Singleton method alias, compatible with ruby 1.9
	class << self
		alias :unsafe_load :load
	end
end
