require "../clustering.rb"

#srand 123

# Example: run on random 2D vectors
vectors = []
200.times{
	# x, y, color
	vectors << [rand, rand]

}

#20.times{|i|
#	20.times{|j|
#		vectors << [i.to_f / 20, j.to_f / 20]
#	}
#}

clustering = Clustering.new(
	vectors, 
	:no_clusters,
	4,
	#:dist,
	#0.5,
	Proc.new {|a,b| ((a[0]-b[0])**2 + (a[1]-b[1])**2)**0.5 }
)
#clustering.cluster_linkage = :max
#clustering.cluster_linkage = :avg
#clustering.cluster_linkage = :min
clustering.cluster!
clustering.print_cluster_info

# Save the data as x y cluster_index for plotting
f = File.open("test_clustering.dat", "w+")
clustering.clusters.each_index{|i|
	clustering.clusters[i].each{|index|
		item = clustering.items[index]
		f.puts "#{item[0]}\t#{item[1]}\t#{i}"
	}
}
f.close

# Plot
f = File.open("test_clustering.gnuplot", "w+")
f.puts 'set palette rgb 33,13,10'
f.puts 'set xrange [0:1]'
f.puts 'set yrange [0:1]'
f.puts 'set key off'
f.puts 'plot "./test_clustering.dat" u 1:2:3 with points lt 7 ps 2  palette;'
f.puts 'pause mouse;'
f.close

system 'gnuplot < test_clustering.gnuplot'

