class ElectrostaticPotential
	# Electrostatic potential on a grid
	attr_reader :grid
	attr_reader :potential

	def initialize
		@grid = []
		@potential = []
	end

	def add_point(x,y,z,p)
		# Add a point, in cuby units (A, kcal/mol/e)
		@grid << Coordinate[x,y,z]
		@potential << p
	end

	def add_point_au(x,y,z,p)
		# Add a point, in atomic units (Bohr, Hartree/e)
		@grid << Coordinate[x,y,z] * BOHR2ANGSTROM
		@potential << p * HARTREE2KCAL
	end

	def write_xyzp(filename)
		file = File.open(filename, "w+")
		@grid.each_index{|i|
			file.printf("%12.6f%12.6f%12.6f%10.4f\n", @grid[i].x, @grid[i].y, @grid[i].z, @potential[i])
		}
		file.close
	end
end
