class TurbomoleControl
	def initialize(filename)
		@filename = filename
		@lines = IO.readlines(filename)
	end

	def get_value(key)
		key.gsub!("$","")
		@lines.each{|line|
			if line =~ /^\$#{key} /
				return line.gsub(/^\$#{key} */,"")
			end
		}
		return nil
	end

	def set_value(key, value)
		key.gsub!("$","")
		found = false
		@lines.each_index{|i|
			line = @lines[i]
			if line =~ /^\$#{key} /
				@lines[i] = "$#{key} #{value}"
				found = true
			end
		}
		unless found
			@lines.each_index{|i|
				line = @lines[i]
				if line =~ /^\$end/
					@lines.insert(i, "$#{key} #{value}")
					return value
				end
			}
		end
		return value
	end

	def delete_key(key)
		key.gsub!("$","")
		@lines.each{|line|
			if line =~ /^\$#{key} /
				@lines.delete(line)
				return line.gsub(/^\$#{key} */,"")
			end
		}
		return nil
	end

	def write!
		f = File.open(@filename, "w+")
		f.puts @lines
		f.close
	end
end
