module ProtocolDataset
	#=======================================================================
	# Classes used for statistical analysis and printing of results
	#=======================================================================
	
	class DataSetCurvePoint
		attr_reader :x
		attr_reader :y_ref
		attr_reader :y

		def initialize(x, y_ref, y)
			@x = x
			@y_ref = y_ref
			@y = y
		end

	end

	class DataSetCurve
		attr_reader :curve_id
		attr_reader :points
		attr_reader :refpoint

		def initialize(curve_id)
			@points = []
		end

		def add_point(x, y_ref, y, refpoint = false)
			point = DataSetCurvePoint.new(x, y_ref, y)
			@points << point
			if refpoint
				@refpoint = point
			end
		end

		def sort_points!
			@points.sort!{|a,b| a.x <=> b.x}
		end

		def size
			return @points.size
		end

	end
end


