module ProtocolDataset
	#=======================================================================
	# Classes used for statistical analysis and printing of results
	#=======================================================================
	
	class DataSetErrors < Array

		def sumsq
			sumsq = 0.0
			each{|e| sumsq += e**2 }
			return sumsq
		end

		def count
			return size
		end

		def rmse
			return (sumsq/count)**0.5
		end

		def mue
			sum = 0.0
			each{|e| sum += e.abs }
			return sum/size
		end

		def mse
			sum = 0.0
			each{|e| sum += e }
			return sum/size
		end

		# min, max from array

		def min_abs
			min = 99.9e99
			each{|e|
				min = e.abs if e.abs < min
			}
			return min
		end

		def max_abs
			max = -99.9e99
			each{|e|
				max = e.abs if e.abs > max
			}
			return max
		end
	end
end
