module ActionsTopology

	#=======================================================================
	# Actions - topology analysis
	#=======================================================================
	
	def topologic_ranks
		@write_geo = false
		puts @geometry.assign_canonical_ranks(:geometry)
	end

	def rmsd_fit_topo
		# Geometry2 is used as a template,
		# geometry is changed
		geometry2 = Geometry.from_file(@settings[:geometry2], @settings)
		geometry = @geometry.reorder_to_match(geometry2, :geometry)

		@messages << "RMSD before fit: #{geometry.rmsd_noshift(geometry2)} A"
		@messages << "RMSD translated: #{geometry.rmsd(geometry2)} A"
		fitted = geometry.fit_rmsd(geometry2)
		@messages << "RMSD after fit:  #{fitted.rmsd(geometry2)} A"
		@geometry = fitted
	end

	def order_by_topology
		# Order by canonical rank, break equivalence using geometric information
		geometry = @geometry.sort_by_canonical_rank(:geometry)
		@geometry = geometry
	end

	def order_template
		# Geometry2 is used as a template
		geometry2 = Geometry.from_file(@settings[:geometry2], @settings)

		geometry = @geometry.reorder_to_match(geometry2, :geometry)
		@geometry = geometry
	end
end
