#!/usr/bin/env ruby

$:.unshift(File.dirname(__FILE__)+"/..").uniq! # Magic line to add path to the executable to $RUBYLIB
require "yaml"
require "/home/rezac/cuby4/protocols/dataset/classes/data_set.rb"
require "/home/rezac/cuby4/classes/compatibility/ruby_backports.rb"

# Help
if ARGV.size != 1
	puts "Use:"
	puts ""
	puts "dataset_plots.rb dataset.yaml"
	puts ""
	puts "item name should be constructed as number ...anything... x_value"
	puts ""
	exit 1
end

# print header
puts "#==============================================================================="
puts "# Plots"
puts "#==============================================================================="
puts ""
puts "plots:"

# load dataset file
set = YAML.unsafe_load(File.open(ARGV[0]))

this_plot = nil
prev_plot = nil
plots = {}
set.items.each_index{|i|
	item = set.items[i]
	name = item.name.strip.split(/ +/)
	x = name.pop.to_f
	num = name.shift
	name = num + " " + name.join(" ")

	unless plots[num]
		prev_plot = this_plot
		this_plot = ProtocolDataset::DataSetPlot.new
		plots[num] = this_plot
		this_plot.name = name
		fn = item.shortname.gsub(/_[0-9.]+$/,"")
		this_plot.filename = fn
		this_plot.first = i
		this_plot.x_values = []
		# Previous plot
		if prev_plot
			prev_plot.last = i - 1
		end
	end
	this_plot.x_values << x
}
this_plot.last = set.items.size - 1

plots.each_pair{ |key, plot|
	puts "- !ruby/object:ProtocolDataset::DataSetPlot"
	puts "  name: \"#{plot.name}\""
	puts "  filename: #{plot.filename}"
	puts "  first: #{plot.first}"
	puts "  last: #{plot.last}"
	puts "  x_values: [ #{plot.x_values.join(', ')} ]"
	puts
}

#--------------------------------------------------
# - !ruby/object:ProtocolDataset::DataSetPlot
#   name: "01 Water ... Water"
#   filename: 01_Water-Water
#   first: 0
#   last: 7
#   x_values: [0.9, 0.95, 1.0, 1.05, 1.1, 1.25, 1.5, 2.0]
# 
#-------------------------------------------------- 
