#!/usr/bin/env ruby
$:.unshift(File.dirname(__FILE__)+"/..").uniq! # Magic line to add path to the executable to $RUBYLIB
require "classes/cuby.rb"
Cuby.load_framework


potfile = ARGV[0]
trianglefile = ARGV[1]

potential = IO.readlines(potfile)
triangles = IO.readlines(trianglefile)

raise "Potential and triangle files must be of the same length" unless potential.size == triangles.size

COLOR_SCALE = [
	[-1000, Vector[0,0,0]],
	[-2.5, Vector[0,0,255]],
	[-1, Vector[0,128,255]],
	[-0.5, Vector[0,255,255]],
	[0.5, Vector[0, 255, 0]],
	[5, Vector[255, 255, 0]],
	[10, Vector[255, 128, 0]],
	[1000, Vector[255, 0, 0]],
	[2000, Vector[255, 0, 0]]
]

def color_scale(pot)
	ci = COLOR_SCALE.size - 1
	COLOR_SCALE.each_index{|i|
		max, col = COLOR_SCALE[i]
		if pot < max && i < ci
			ci = i
		end
	}
	color = COLOR_SCALE[ci][1]

	#smooth border
	#--------------------------------------------------
	# smooth = 0.3
	# if (COLOR_SCALE[ci][0] - pot) < smooth
	# 	x = (COLOR_SCALE[ci][0] - pot)/smooth
	# 	nearcol = COLOR_SCALE[ci+1][1]
	# 	color = (x)*color + (1.0-x) * nearcol
	# end
	# if (pot - COLOR_SCALE[ci-1][0]) < smooth
	# 	x = (pot - COLOR_SCALE[ci-1][0])/smooth
	# 	nearcol = COLOR_SCALE[ci-1][1]
	# 	#nearcol = Vector[0,0,0]
	# 	color = (x)*color + (1.0-x) * nearcol
	# end
	#-------------------------------------------------- 
	return color.to_a
end

#===============================================================================
# Color the triangles by the potential
#===============================================================================
potential.each_index{|i|
	x,y,z,pot = potential[i].strip.split.map{|v| v.to_f}

	rgb = color_scale(pot).map{|c| "%d" % c}

	puts triangles[i].strip + "\t" + rgb.join("\t")

}


